**Cette page a été importée automatiquement de notre ancien wiki mais n'a pas encore été révisée.**

# How To Parted

Pour les disques de plus de 1.8 To, il faut utiliser un partitionnement de type GPT.
fdisk/cfdisk ne supporte pas les partitionnements GPT, et il faut utiliser *parted*.

## Créer une table de partition

~~~
# parted /dev/sdb

(parted) p                                                                
Error: /dev/sdb: unrecognised disk label                                  

(parted) mklabel gpt                                                      

(parted) p                                                                
Model: IFT DS S12E-G2140-4 (scsi)
Disk /dev/sdb: 7998GB
Sector size (logical/physical): 512B/512B
Partition Table: gpt
~~~

## Créer une partition de boot pour système UEFI

~~~
# parted /dev/sdx

(parted) mkpart ESP fat32 1MiB 513MiB
~~~

## Créer une partition avec parted

~~~
# parted /dev/sdb

(parted) mkpart primary ext4 0% 100%
(parted) p
Number  Start   End     Size    File system  Name     Flags
 1      1049kB  2000GB  2000GB  ntfs         primary
(parted) align-check optimal 1
1 aligned

(parted) q

# mkfs.ext4 /dev/sdb1
~~~

~~~
# parted /dev/loop0

(parted) mkpart primary ext2 0% 95%
(parted) mkpart primary linux-swap 95% 96%                             
(parted) mkpart primary linux-swap 96% 97%                               
(parted) p                                                                
Model:  (file)
Disk /dev/loop0: 85.9GB
Sector size (logical/physical): 512B/512B
Partition Table: msdos

Number  Start   End     Size    Type     File system  Flags
 1      1049kB  81.6GB  81.6GB  primary  ext4         boot
 2      81.6GB  82.5GB  859MB   primary
 3      82.5GB  83.3GB  859MB   primary

(parted) q
~~~

## Resizer une partition avec parted (à froid)

Le _resize_ de parted ne supporte pas ext4.
On utilisera plutôt cfdisk/fdisk/sfdisk pour supprimer/recréer la partition (attention bien conserver le même secteur de début !!!)

## Flag boot

~~~
(parted) set 1 boot on                                                    
~~~

## Créer des volumes RAID

Après avoir créé la partition qui va accueillir le RAID, comme une partition conventionnelle, il suffit d'activer le flag RAID sur cette dernière.
Par exemple, pour la première partition d'un disque :

~~~
(parted) set 1 raid on
~~~

Puis initialiser le RAID avec MDADM comme d'habitude :

~~~
mdadm --create /dev/mdX --chunk=64 --level=raid1 --raid-devices=2 /dev/sdX1 /dev/sdY1
~~~